%global ivykis_ver 0.42.3

%global syslog_ng_major_ver 4
%global syslog_ng_minor_ver 3
%global syslog_ng_patch_ver 1
%global syslog_ng_major_minor_ver %{syslog_ng_major_ver}.%{syslog_ng_minor_ver}
%global syslog_ng_ver %{syslog_ng_major_ver}.%{syslog_ng_minor_ver}.%{syslog_ng_patch_ver}

Name:    syslog-ng
Version: %{syslog_ng_ver}
Release:    1%{?dist}
Summary: Next-generation syslog server

License: GPLv2+
URL:     https://www.syslog-ng.com/products/open-source-log-management/
Source0: https://github.com/balabit/syslog-ng/releases/download/syslog-ng-%{version}/%{name}-%{version}.tar.gz
Source1: syslog-ng.conf
Source2: syslog-ng.logrotate
Source3: syslog-ng.service

BuildRequires: make
BuildRequires: bison
BuildRequires: cyrus-sasl-devel
BuildRequires: flex
BuildRequires: glib2-devel
BuildRequires: hiredis-devel
BuildRequires: ivykis-devel >= %{ivykis_ver}
BuildRequires: json-c-devel
BuildRequires: libcap-devel
BuildRequires: libcurl-devel
BuildRequires: libdbi-devel
BuildRequires: libesmtp-devel
BuildRequires: libmaxminddb-devel
BuildRequires: libnet-devel
BuildRequires: librabbitmq-devel
BuildRequires: libtool
BuildRequires: libuuid-devel
BuildRequires: libxslt
BuildRequires: mongo-c-driver-devel
BuildRequires: net-snmp-devel
BuildRequires: openssl-devel
BuildRequires: pcre2-devel
BuildRequires: perl-generators
BuildRequires: pkgconfig
BuildRequires: python3-devel
BuildRequires: riemann-c-client-devel
BuildRequires: snappy-devel
BuildRequires: systemd-devel
BuildRequires: systemd-units
BuildRequires: librdkafka-devel
BuildRequires: zlib-devel
BuildRequires: paho-c-devel

BuildRequires: python3-pip
BuildRequires:  python3-cachetools
BuildRequires:  python3-certifi
BuildRequires:  python3-charset-normalizer
BuildRequires:  python3-google-auth
BuildRequires:  python3-idna
BuildRequires:  python3-kubernetes
BuildRequires:  python3-oauthlib
BuildRequires:  python3-pyasn1
BuildRequires:  python3-pyasn1-modules
BuildRequires:  python3-dateutil
BuildRequires:  python3-PyYAML
BuildRequires:  python3-requests
BuildRequires:  python3-requests-oauthlib
BuildRequires:  python3-rsa
BuildRequires:  python3-six
BuildRequires:  python3-urllib3
BuildRequires:  python3-websocket-client

%ifarch i686
%bcond_with bpf
%bcond_with otel
%else
%bcond_without bpf
%bcond_without otel
%endif

%if %{with bpf}
BuildRequires: libbpf-devel
BuildRequires: bpftool
BuildRequires: clang
%endif

%if %{with otel}
BuildRequires:  grpc-devel
BuildRequires:  protobuf-devel
%endif

Requires: logrotate
Requires: ivykis >= %{ivykis_ver}
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

Provides: syslog
Provides: syslog-ng-vim = %{version}-%{release}

Conflicts: filesystem < 3



%description
syslog-ng is an enhanced log daemon, supporting a wide range of input and
output methods: syslog, unstructured text, message queues, databases (SQL
and NoSQL alike) and more.

Key features:

 * receive and send RFC3164 and RFC5424 style syslog messages
 * work with any kind of unstructured data
 * receive and send JSON formatted messages
 * classify and structure logs with builtin parsers (csv-parser(),
   db-parser(), ...)
 * normalize, crunch and process logs as they flow through the system
 * hand on messages for further processing using message queues (like
   AMQP), files or databases (like PostgreSQL or MongoDB).


%package slog
Summary: secure logging support for %{name}
Requires: %{name} = %{version}-%{release}

%description slog
This module supports secure message transfer and storage (experimental).

%package libdbi
Summary: Libdbi support for %{name}
Requires: %{name} = %{version}-%{release}

%description libdbi
This module supports a large number of database systems via libdbi.


%package mongodb
Summary: MongoDB support for %{name}
Requires: %{name} = %{version}-%{release}

%description mongodb
This module supports the mongodb database via libmongo-client.

%package kafka
Summary: Kafka support for %{name}
Requires: %{name} = %{version}-%{release}

%description kafka
This module supports sending logs to Kafka through librdkafka.


%package smtp
Summary: SMTP support for %{name}
Requires: %{name} = %{version}-%{release}

%description smtp
This module supports sending e-mail alerts through an smtp server.


%package snmp
Summary: SNMP support for %{name}
Requires: %{name} = %{version}-%{release}

%description snmp
This module adds support for SNMP destination.


%package geoip
Summary: GeoIP support for %{name}
Requires: %{name} = %{version}-%{release}

%description geoip
This template function returns the 2-letter country code of
any IPv4 address or host.


%package redis
Summary: Redis support for %{name}
Requires: %{name} = %{version}-%{release}

%description redis
This module supports the redis key-value store via hiredis.


%package riemann
Summary: Riemann support for %{name}
Requires: %{name} = %{version}-%{release}

%description riemann
This module supports the riemann monitoring server.


%package http
Summary: HTTP support for %{name}
Requires: %{name} = %{version}-%{release}

%description http
This module supports the http destination.


%package opentelemetry
Summary: OpenTelemetry support for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description opentelemetry
This module adds OpenTelemetry support.


%package bpf
Summary: Faster UDP log collection for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description bpf
This module provides faster UDP log collection using bpf.


%package amqp
Summary: AMQP support for %{name}
Requires: %{name} = %{version}-%{release}

%description amqp
This module supports the AMQP destination.

%package mqtt
Summary: mqtt support for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description mqtt
This module supports sending logs to MQTT through paho-c.

%package python
Summary: Python support for %{name}
Requires: %{name} = %{version}-%{release}

%description python
This package provides python support for syslog-ng.

%package python-modules
Summary:        Python-based drivers for syslog-ng
Group:          System/Libraries
Requires:       %{name} = %{version}
Requires:       %{name}-python
Requires:  python3-cachetools
Requires:  python3-certifi
Requires:  python3-charset-normalizer
Requires:  python3-google-auth
Requires:  python3-idna
Requires:  python3-kubernetes
Requires:  python3-oauthlib
Requires:  python3-pyasn1
Requires:  python3-pyasn1-modules
Requires:  python3-dateutil
Requires:  python3-PyYAML
Requires:  python3-requests
Requires:  python3-requests-oauthlib
Requires:  python3-rsa
Requires:  python3-six
Requires:  python3-urllib3
Requires:  python3-websocket-client

%description python-modules
This package provides Python-based (Kubernetes, Hypr) drivers for syslog-ng.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -p 1

rm -rf lib/ivykis
rm -rf modules/afamqp/rabbitmq-c
rm -rf modules/afmongodb/mongo-c-driver

%{__sed} -i 's|^#!/usr/local/bin/perl|#!%{__perl}|' contrib/relogger.pl

%{__chmod} -c a-x contrib/syslog2ng

/usr/bin/iconv -f iso8859-1 -t utf-8 AUTHORS > AUTHORS.conv && \
    %{__mv} -f AUTHORS.conv AUTHORS

%py3_shebang_fix lib/merge-grammar.py
touch -r lib/cfg-grammar.y lib/merge-grammar.py

%build
%configure \
    --prefix=%{_prefix} \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --localstatedir=%{_sharedstatedir}/%{name} \
    --datadir=%{_datadir} \
    --with-module-dir=%{_libdir}/%{name} \
    --with-systemdsystemunitdir=%{_unitdir} \
    --with-ivykis=system \
    --with-mongoc=system \
    --with-embedded-crypto \
    --enable-manpages \
    --enable-ipv6 \
    --enable-spoof-source \
    --with-linux-caps=auto \
    --enable-sql \
    --enable-kafka \
    --enable-mqtt \
    --enable-json \
    --enable-ssl \
    --enable-smtp \
    --enable-geoip \
    --enable-shared \
    --disable-static \
    --enable-dynamic-linking \
    --enable-systemd \
    --enable-redis \
    --enable-amqp \
    --enable-python \
    --with-python=3 \
    --with-python-packages=system \
    --disable-java \
    --disable-java-modules \
    --enable-afsnmp \
%if %{with otel}
    --enable-cpp --enable-grpc \
%endif
%if %{with bpf}
    --enable-ebpf \
%endif
    --enable-riemann

make %{_smp_mflags}


%install
make DESTDIR=%{buildroot} install

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/%{name}/conf.d
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}/syslog-ng.conf

%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/syslog

%{__install} -d -m 755 %{buildroot}%{_prefix}/lib/systemd/system
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service

%{__install} -d -m 755 %{buildroot}/%{_sharedstatedir}/%{name}

%{__install} -d -m 755 %{buildroot}%{_includedir}/%{name}
%{__install} -p -m 644 config.h %{buildroot}%{_includedir}/%{name}
%{__install} -p -m 644 lib/*.h %{buildroot}%{_includedir}/%{name}

%{__install} -d -m 755 %{buildroot}%{_datadir}/%{name}/vim/ftdetect
%{__install} -d -m 755 %{buildroot}%{_datadir}/%{name}/vim/syntax
%{__install} -p -m 644 contrib/vim/ftdetect/syslog-ng.vim %{buildroot}%{_datadir}/%{name}/vim/ftdetect
%{__install} -p -m 644 contrib/vim/syntax/syslog-ng.vim %{buildroot}%{_datadir}/%{name}/vim/syntax
for vimver in 73 ; do
    %{__install} -d -m 755 %{buildroot}%{_datadir}/vim/vim$vimver/ftdetect
    %{__install} -d -m 755 %{buildroot}%{_datadir}/vim/vim$vimver/syntax
    cd %{buildroot}%{_datadir}/vim/vim$vimver
    ln -s ../../../%{name}/vim/ftdetect/syslog-ng.vim ftdetect
    ln -s ../../../%{name}/vim/syntax/syslog-ng.vim syntax
    cd -
done

find %{buildroot} -name "*.la" -exec rm -f {} \;

rm %{buildroot}%{_unitdir}/%{name}@.service


%post
ldconfig
%systemd_post syslog-ng.service


%preun
%systemd_preun syslog-ng.service


%postun
ldconfig
%systemd_postun_with_restart syslog-ng.service


%triggerun -- syslog-ng < 3.2.3
if /sbin/chkconfig --level 3 %{name} ; then
    /bin/systemctl enable %{name}.service >/dev/null 2>&1 || :
fi

%triggerin -- vim-common
VIMVERNEW=`rpm -q --qf='%%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ -d %{_datadir}/vim/vim${VIMVERNEW}/ftdetect ] && \
    cd %{_datadir}/vim/vim${VIMVERNEW}/ftdetect && \
    ln -sf ../../../%{name}/vim/ftdetect/syslog-ng.vim . || :
[ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
    cd %{_datadir}/vim/vim${VIMVERNEW}/syntax && \
    ln -sf ../../../%{name}/vim/syntax/syslog-ng.vim . || :

%triggerun -- vim-common
VIMVEROLD=`rpm -q --qf='%%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ $2 = 0 ] && rm -f %{_datadir}/vim/vim${VIMVEROLD}/ftdetect/syslog-ng.vim %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :

%triggerpostun -- vim-common
VIMVEROLD=`rpm -q --qf='%%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
VIMVERNEW=`rpm -q --qf='%%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
if [ $1 = 1 ]; then
    rm -f %{_datadir}/vim/vim${VIMVEROLD}/ftdetect/syslog-ng.vim %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :
    [ -d %{_datadir}/vim/vim${VIMVERNEW}/ftdetect ] && \
        cd %{_datadir}/vim/vim${VIMVERNEW}/ftdetect && \
        ln -sf ../../../%{name}/vim/ftdetect/syslog-ng.vim . || :
    [ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
        cd %{_datadir}/vim/vim${VIMVERNEW}/syntax && \
        ln -sf ../../../%{name}/vim/syntax/syslog-ng.vim . || :
fi

%files
%doc AUTHORS COPYING NEWS.md
%doc contrib/{relogger.pl,syslog2ng,syslog-ng.conf.doc}

%dir %{_sysconfdir}/syslog-ng
%dir %{_sysconfdir}/syslog-ng/conf.d
%dir %{_sysconfdir}/syslog-ng/patterndb.d
%config(noreplace) %{_sysconfdir}/logrotate.d/syslog
%config(noreplace) %{_sysconfdir}/syslog-ng/syslog-ng.conf

%{_unitdir}/syslog-ng.service

%dir %{_sharedstatedir}/syslog-ng

%{_sbindir}/syslog-ng
%{_sbindir}/syslog-ng-ctl
%{_sbindir}/syslog-ng-debun

%{_bindir}/dqtool
%{_bindir}/loggen
%{_bindir}/pdbtool
%{_bindir}/persist-tool
%{_bindir}/update-patterndb
%{_bindir}/syslog-ng-update-virtualenv

%{_libdir}/libevtlog-%{syslog_ng_major_minor_ver}.so.0
%{_libdir}/libevtlog-%{syslog_ng_major_minor_ver}.so.0.0.0
%{_libdir}/libloggen_helper-%{syslog_ng_major_minor_ver}.so.0
%{_libdir}/libloggen_helper-%{syslog_ng_major_minor_ver}.so.0.0.0
%{_libdir}/libloggen_plugin-%{syslog_ng_major_minor_ver}.so.0
%{_libdir}/libloggen_plugin-%{syslog_ng_major_minor_ver}.so.0.0.0
%{_libdir}/libsecret-storage.so.0
%{_libdir}/libsecret-storage.so.0.0.0
%{_libdir}/libsyslog-ng-%{syslog_ng_major_minor_ver}.so.0
%{_libdir}/libsyslog-ng-%{syslog_ng_major_minor_ver}.so.0.0.0

%dir %{_libdir}/syslog-ng
%{_libdir}/syslog-ng/*.so

%dir %{_libdir}/syslog-ng/loggen
%{_libdir}/syslog-ng/loggen/libloggen_socket_plugin.so
%{_libdir}/syslog-ng/loggen/libloggen_ssl_plugin.so

%exclude %{_libdir}/syslog-ng/libafamqp.so
%exclude %{_libdir}/syslog-ng/libafmongodb.so
%exclude %{_libdir}/syslog-ng/libafsmtp.so
%exclude %{_libdir}/syslog-ng/libafsql.so
%exclude %{_libdir}/syslog-ng/libgeoip2-plugin.so
%exclude %{_libdir}/syslog-ng/libhttp.so
%exclude %{_libdir}/syslog-ng/libmod-python.so
%exclude %{_libdir}/syslog-ng/libredis.so
%exclude %{_libdir}/syslog-ng/libriemann.so
%exclude %{_libdir}/syslog-ng/libafsnmp.so
%exclude %{_libdir}/syslog-ng/libkafka.so
%exclude %{_libdir}/syslog-ng/libotel.so
%exclude %{_libdir}/syslog-ng/libmqtt.so
%exclude %{_libdir}/syslog-ng/libebpf.so

%dir %{_datadir}/%{name}
%{_datadir}/%{name}/vim/ftdetect/syslog-ng.vim
%{_datadir}/%{name}/vim/syntax/syslog-ng.vim
%ghost %{_datadir}/vim/

%{_datadir}/syslog-ng/include/

%{_datadir}/syslog-ng/xsd/

%{_datadir}/syslog-ng/smart-multi-line.fsm

%{_mandir}/man1/loggen.1*
%{_mandir}/man1/pdbtool.1*
%{_mandir}/man1/syslog-ng-ctl.1*
%{_mandir}/man1/syslog-ng-debun.1*
%{_mandir}/man1/dqtool.1*
%{_mandir}/man5/syslog-ng.conf.5*
%{_mandir}/man8/syslog-ng.8*
%{_mandir}/man1/persist-tool.1*


%files slog
%{_bindir}/slogkey
%{_bindir}/slogencrypt
%{_bindir}/slogverify
%{_libdir}/syslog-ng/libsecure-logging.so
%{_mandir}/man1/slogkey.1*
%{_mandir}/man1/slogencrypt.1*
%{_mandir}/man1/slogverify.1*
%{_mandir}/man7/secure-logging.7*

%files libdbi
%{_libdir}/syslog-ng/libafsql.so

%files kafka
%{_libdir}/%{name}/libkafka.so

%files mongodb
%{_libdir}/syslog-ng/libafmongodb.so


%files redis
%{_libdir}/syslog-ng/libredis.so

%files mqtt
%{_libdir}/%{name}/libmqtt.so

%files smtp
%{_libdir}/syslog-ng/libafsmtp.so

%files snmp
%{_libdir}/%{name}/libafsnmp.so


%files geoip
%{_libdir}/syslog-ng/libgeoip2-plugin.so


%files riemann
%{_libdir}/syslog-ng/libriemann.so


%files http
%{_libdir}/syslog-ng/libhttp.so


%files amqp
%{_libdir}/syslog-ng/libafamqp.so

%if %{with bpf}
%files bpf
%{_libdir}/%{name}/libebpf.so
%endif

%if %{with otel}
%files opentelemetry
%{_libdir}/%{name}/libotel.so
%endif

%files python
%{_libdir}/%{name}/libmod-python.so
%dir %{_sysconfdir}/%{name}/python
%{_sysconfdir}/%{name}/python/README.md
%{_libdir}/%{name}/python/syslogng-1.0-py%{python3_version}.egg-info
%{_libdir}/%{name}/python/syslogng/*
%{_libdir}/%{name}/python/requirements.txt
%exclude %{_libdir}/syslog-ng/python/syslogng/modules/

%files python-modules
%dir %{_libdir}/syslog-ng/python/syslogng/modules/
%{_libdir}/syslog-ng/python/syslogng/modules/*

%files devel
%{_datadir}/syslog-ng/tools/
%{_includedir}/syslog-ng/
%{_libdir}/libevtlog.so
%{_libdir}/libloggen_helper.so
%{_libdir}/libloggen_plugin.so
%{_libdir}/libsecret-storage.so
%{_libdir}/libsyslog-ng-native-connector.a
%{_libdir}/libsyslog-ng.so
%{_libdir}/pkgconfig/syslog-ng-native-connector.pc
%{_libdir}/pkgconfig/syslog-ng.pc


%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.3.1-1
- initial build
